% Example 7.1 Seepage Flow Under a Dam with Sheetpile
% f = Velocity potential [m^2/s];
% N = Numerical index defining the boundary conditions;
% Dx = Spatial step in the x-direction[m];
% Dy = Spatial step in the y-direction [m];
% nx = Number of spatial steps in the x-direction;
% ny = Number of spatial steps in the y-direction;
% nn = Number of iterations;
clc; clear all; close all;
load indices.txt
index=indices;
% Subroutine N=fm(i,j,index): For definition of the b.c. indices nn;
nx=30;
ny=30;
Dx=50;
Dy=10;
nn=1500;
% Initialization of the variable;
for i=1:nx
    for j=1:ny
        f(i,j)=0;
    end
end
chk=0;
for k=1:nn
    for i=1:nx
        for j=1:ny
            N=fm(i,j,index);
            if N>0
                chk=1000;
            end
            if chk~=1000
                No=fm(i,j+1,index);
                Nu=fm(i,j-1,index);
                Nr=fm(i+1,j,index);
                Nl=fm(i-1,j,index);
                fo=f(i,j+1);
                fu=f(i,j-1);
                fr=f(i+1,j);
                fl=f(i-1,j);
                % Impervious boundary;
                if No==1
                    fo=f(i,j);
                end
                if Nu==1
                    fu=f(i,j);
                end
                if Nr==1
                    fr=f(i,j);
                end
                if Nl==1
                    fl=f(i,j);
                end
                % Constant head boundary;
                if No>1
                    fo=No;
                end
                if Nu>1
                    fu=Nu;
                end
                if Nr>1
                    fr=Nr;
                end
                if Nl>1
                    fl=Nl;
                end
                temp=f(i,j);
                f(i,j)=((fr+fl)/Dx^2+(fo+fu)/Dy^2)/(2/Dx^2+2/Dy^2);
                dif=abs(temp-f(i,j));
            end
            chk=0;
        end
    end
    diff(k)=dif;
    kk=k
    fnew=f;
end
i=1:nx;
j=1:ny;
fpp=fnew(i,j);
plot(1:nn,diff,'b','Linewidth',1.5)
xlabel('Number of iterations');
ylabel('Absolute value of the computational error')
axis([0,100,0,0.7]);
figure
surf(i,j,fpp')
figure
contour(i,j,fpp')


