% Example 9.1 Finite Element Method
% dx = Length of the finite element;
% imax = Number of nodes;
% a = Matrix coefficients;
% c = Vector of constants;
% f = value of functions at the nodes;
dx=0.1;
imax=11;
imax1=imax-1;
for i=1:imax
    f(i)=0;
    c(i)=0;
    for j=1:imax
        a(i,j)=0;
    end
end
for i=1:imax1
    a(i,i)=a(i,i)+1/dx;
    a(i,i+1)=a(i,i+1)-1/dx;
    a(i+1,i)=a(i+1,i)-1/dx;
    a(i+1,i+1)=a(i+1,i+1)+1/dx;
    c(i)=c(i)+dx^2*(i*(i^2-(i-1)^2)/2-(i^3-(i-1)^3)/3);
    c(i+1)=c(i+1)+dx^2*((i^3-(i-1)^3)/3-(i-1)*(i^2-(i-1)^2)/2);
end
iter=0;
for k=1:1000
    iter=iter+1;
    difmax=0;
    for i=2:imax1
        f(i)=(c(i)-a(i,i+1)*f(i+1)-a(i,i-1)*f(i-1))/a(i,i);
    end
end
x=0;
for i=1:imax
    fexact(i)=x*(1-x^2)/6;
    x=x+dx;
end
plot(0:imax-1,f,'b','Linewidth',2)
hold on
plot(0:imax-1,fexact,'r')
xlabel('Solution domain x 10^-^1')
ylabel('Function f(x)')
legend('FE Galerkin','Exact Solution',2)